C*****************************************
       program bin triangles
C*****************************************
       implicit none
	   include 'common.fi'

       write(6,*) '================================================='
	   write(6,*) ' PROGRAM TO READ TRIANGLE DATA, FIND MEAN, '
       write(6,*) ' VALUES IN BINS AND COMPARE TO VELOCITY MEAN '
       write(6,*) ' '
	   write(6,*) ' rohrer@cmu.edu'
	   write(6,*) ' version 02/20/2021'
       write(6,*) '================================================='
	   
	   version = 'version 02/20/2021'

       !some formating statements used to format typed output
  5    format(A,A)
  6    format(A)
  7    format(I6,A)
  15   format(A,I9,A)
  22   format(f6.4,2x,f6.4,2x,f6.4,2x,I7,4x,f6.4)
  23   format(12f11.5)
  24   format(12f8.4)

       open(21, file='input.txt', status='old') ! Open the file with the program
                                                ! parameters.
	   read(21,*) keyword                       ! This reads the filename with the data
       point = index(keyword,'.') - 1
       write(6,5)'I am going to look for data in the file labeled: ', keyword
       close(21)

       !for current data, curv varies from 0 to 0.6. So, in increments of 0.003,
       !use 200 bins
       !vel varies from 0 to 1, if dispersed in 200 bins, increments of 0.005

       !initialized the bins bins(4,200)
       do i=1,200
        bins(1,i)=0.003*i
        bins(2,i)=0.0
        bins(3,i)=0.0
        bins(4,i)=0.0
        bins(5,i)=0.0
       enddo

       ! This part is to determines the total number of lines
       ! in the data file and assigns it to the variable, nnline
		nnline = 0 ! Initialize counter
		open(41, file=keyword, status='old') ! open the file
 60     continue
		read(41,*,end=61) ! read line, if end of file, goto 61
		nnline=nnline+1  ! Increment counter
		goto 60
 61     continue
        close(41)  ! we are finished, close the file
		write(6,15) 'There are  ',nnline,' lines in the data file.'
        ! Check each line for the string '#'. If found, we know this line
        ! is part of the header.  If not, we have reached the data section.
	    open(41, file=keyword, status='old') ! open the file
        header = 0 ! Initialize counter
        hash = 0   ! Initialize flag
	    do i=1,nnline  ! loop over each line in the file
	     read(41, "(a)") inline    ! reads line into a string
	     hash = index(inline, '#') ! if the character "#" in the string, hash>1.
	     if (hash.ne.0) then       ! check the flag
	      header=header+1          ! when "#" found, it is a header line
		  hash=0                   ! reset the flag
	     else
		  goto 80                  ! when hash is = 0, we have reached the end of the header
	     endif
	    enddo  ! closes i=1,nnline
 80    close(41)				   ! close the file
	   write(6,7)header,' lines in the header'

	   ! This opens the output file, where results are written
       open(31, file=keyword(1:point)//'_binned.txt', status='unknown')

       ! Now we read the data
       open(41, file=keyword, status='old') ! Open the input file
       nline = 0 ! Before reading the data, we have to read the neader
       do i=1,header
        read(41, "(a)") inline ! read a line of the header
        write(31, "(a)")inline ! write that line into the output file
       enddo! closes i=1,header
       write(31, 5)'# written by bin faces: ',version
       write(31, 5)'# initial file: ',keyword
       write(31,6)'bin     curv    vel      number    std_dev' !write column labels
       write(6,6)'bin     curv    vel      number    std_dev'

       ! Next is the start of the main loop, reading and
       ! classifying one line of data at a time.
       do kk=header+1,nnline !start on the line after the header, continue to end.
        read(41,24) e1(1), e1(2), e1(3), e2(1), e2(2), e2(3),
     &  normal(1),normal(2),normal(3),area, curv, vel
         area=abs(area)
         curv=abs(curv)
         vel=abs(vel)
        ind = floor((curv*200)/0.6)+1
        if (ind.eq.0) ind=1
        if (ind.gt.200) then  ! make sure it is not > the uper limit
         ind=200
         !write(6,*)'curvature out of bounds',curv
        endif
        bins(2,ind)=bins(2,ind)+curv
        bins(3,ind)=bins(3,ind)+vel
        bins(4,ind)=bins(4,ind)+1.0
       enddo    ! This closes kk=header+1,nnline, the loop over each line of data.
       close(41)

       !now we compute the standard deviations
       open(41, file=keyword, status='old') ! Open the input file
       do i=1,header
        read(41, "(a)") inline ! read a line of the header
       enddo! closes i=1,header
       ! Next is the start of the main loop, reading and
       ! classifying the mean squared differences.
       do kk=header+1,nnline !start on the line after the header, continue to end.
        read(41,24) e1(1), e1(2), e1(3), e2(1), e2(2), e2(3),
     &  normal(1),normal(2),normal(3),area, curv, vel
         area=abs(area)
         curv=abs(curv)
         vel=abs(vel)
        ind = floor((curv*200)/0.6)+1
        if (ind.eq.0) ind=1
        if (ind.gt.200) then  ! make sure it is not > the uper limit
         ind=200
         !write(6,*)'curvature out of bounds',curv
        endif
        bins(5,ind)=bins(5,ind)+((bins(3,ind)/bins(3,ind))-vel)**2   ! add squared difference curv
       enddo    ! This closes kk=header+1,nnline, the loop over each line of data.
       close(41)

       do k=1,200
        write(31,22)bins(1,k), bins(2,k)/bins(4,k), bins(3,k)/bins(4,k), int(bins(4,k)), sqrt(bins(5,k)/bins(4,k))
        write(6,22)bins(1,k), bins(2,k)/bins(4,k), bins(3,k)/bins(4,k), int(bins(4,k)), sqrt(bins(5,k)/bins(4,k))
       enddo ! closes the k=1,200 loop

 9000  continue

       close(31)
       end






	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   