C*****************************************
       program bin triangles
C*****************************************
       implicit none
	   include 'common.fi'

       write(6,*) '================================================='
	   write(6,*) ' PROGRAM TO READ TRIANGLE DATA, FIND MEAN, '
       write(6,*) ' VALUES IN BINS AND COMPARE TO VELOCITY MEAN '
       write(6,*) ' '
	   write(6,*) ' rohrer@cmu.edu'
	   write(6,*) ' version 02/19/2021'
       write(6,*) '================================================='
	   
	   version = 'version 02/19/2021'

       !some constants that might be useful
       pi = 4.0*atan(1.0)
       high_val=0
       high_vel=0
       !some formating statements used to format typed output
  5    format(A,A)
  6    format(A)
  10   format(I6,4F6.2)
  13   format(A,f4.1)
  14   format(A,I2,2X,A,I2)
  15   format(A,I7,A)
  17   format(f5.1,6x,F6.4,5x,F6.4,5x,F8.4,5x,F6.4)
  18   format(A,f6.3,A,f6.3,A,f6.3,A,f6.3,A,f6.3,A,3f6.3)
  19   format(f5.2,A,f5.2,A,f5.2,A,f5.2,A)
  20   format(A,f6.3,A,f6.3,A,f6.3)
  21   format(A,f6.3,2f7.3,A)
  22   format(f6.4,2x,f6.4,2x,f6.4,2x,I7)
  23   format(12f11.5)
  28   format(12f8.4)

       open(21, file='input.txt', status='old') ! Open the file with the program
                                                ! parameters.
	   read(21,*) keyword                       ! This reads the filename with the data

       point = index(keyword,'.') - 1

       write(6,5)'I am going to look for data in the file labeled: ', keyword
       close(21)

       !for current data, curv varies from 0 to 0.6 in increments of 0.003
       !so use 200 bins
       !vel varies from 0 to 1, use 200 bins with increments of 0.005
!!

       !initialized the bins bins(4,200)
       do i=1,200
        bins(1,i)=0.003*i
        bins(2,i)=0.0
        bins(3,i)=0.0
        bins(4,i)=0.0
       enddo

       ! This part is to determines the total number of lines
       ! in the data file and assigns it to the variable, nnline
		nnline = 0 ! Initialize counter
		open(41, file=keyword, status='old') ! open the file
 60     continue
		read(41,*,end=61) ! read line, if end of file, goto 61
		nnline=nnline+1  ! Increment counter
		goto 60
 61     continue
        close(41)  ! we are finished, close the file
		write(6,15) 'There are  ',nnline,' lines in the data file.'
		
        ! Check each line for the string '#'. If found, we know this line
        ! is part of the header.  If not, we have reached the data section.
	    open(41, file=keyword, status='old') ! open the file
        header = 0 ! Initialize counter
        hash = 0   ! Initialize flag
	    do i=1,nnline  ! loop over each line in the file
	     read(41, "(a)") inline    ! reads line into a string
	     hash = index(inline, '#') ! if the character "#" in the string, hash>1.
	     if (hash.ne.0) then       ! check the flag
	      header=header+1          ! when "#" found, it is a header line
		  hash=0                   ! reset the flag
	     else
		  goto 80                  ! when hash is = 0, we have reached the end of the header
	     endif
	    enddo  ! closes i=1,nnline
 80    close(41)				   ! close the file
	   write(6,*)header,' lines in the header'





	   ! This opens the output file, where results are written
       open(31, file=keyword(1:point)//'_binned.txt', status='unknown')

       ! Now we read the data
       open(41, file=keyword, status='old') ! Open the input file
       nline = 0 ! Before reading the data, we have to read the neader
       do i=1,header
        read(41, "(a)") inline ! read a line of the header
        write(31, "(a)")inline ! write that line into the output file
        write(31, 6)inline
       enddo! closes i=1,header
       write(31, 5)'# written by bin triangles: ',version
       write(31, 5)'# initial file: ',keyword

       ! Next is the start of the main loop, reading reading and
       ! analyzing one line of data at a time.
       do kk=header+1,nnline !start on the line after the header, continue to end.
        read(41,*) e1(1), e1(2), e1(3), e2(1), e2(2), e2(3), normal(1),normal(2),normal(3), area, curv, vel
         area=abs(area)
         curv=abs(curv)
         vel=abs(vel)

        ind = floor((curv*200)/0.6)+1
        if (ind.eq.0) ind=1
        if (ind.gt.200) then  ! make sure it is not > the uper limit
         ind=200
         !write(6,*)'curvature out of bounds',curv
        endif

        bins(2,ind)=bins(2,ind)+curv
        bins(3,ind)=bins(3,ind)+vel
        bins(4,ind)=bins(4,ind)+1.0


         ! when you reach this point, the line has been written or ignored
 1000    continue ! so we go to the next line of the data file and repeat
       enddo    ! This closes kk=header+1,nnline, the loop over each line of data.

       do k=1,200
          write(31,22)bins(1,k), bins(2,k)/bins(4,k), bins(3,k)/bins(4,k), int(bins(4,k))
          write(6,22)bins(1,k), bins(2,k)/bins(4,k), bins(3,k)/bins(4,k), int(bins(4,k))

       enddo ! closes the k=1,200 loop





 9000    continue


         close(31)
       end






	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   