C*****************************************
       program condition faces
C*****************************************
       implicit none
	   include 'common.fi'

       write(6,*) '================================================='
	   write(6,*) ' PROGRAM TO READ FACE DATA, REMOVE BAD VALUES, '
       write(6,*) ' AND REWRITE A FILE WITH THE GOOD DATA '
       write(6,*) ' '
	   write(6,*) ' rohrer@cmu.edu'
	   write(6,*) ' version 02/18/2021'
       write(6,*) '================================================='
	   
	   version = 'version 02/18/2021'

       !some constants that might be useful
       pi = 4.0*atan(1.0)
       high_val=0
       high_vel=0
       !some formating statements used to format typed output
  5    format(A,A)
  6    format(A)
  10   format(I6,4F6.2)
  13   format(A,f4.1)
  14   format(A,I2,2X,A,I2)
  15   format(A,I7,A)
  17   format(f5.1,6x,F6.4,5x,F6.4,5x,F8.4,5x,F6.4)
  18   format(A,f6.3,A,f6.3,A,f6.3,A,f6.3,A,f6.3,A,3f6.3)
  19   format(f5.2,A,f5.2,A,f5.2,A,f5.2,A)
  20   format(A,f6.3,A,f6.3,A,f6.3)
  21   format(A,f6.3,2f7.3,A)
  22   format(A,f9.4)
  23   format(12f11.5)
  24   format(12f12.4)
  28   format(12f8.4)

       open(21, file='input.txt', status='old') ! Open the file with the program
                                                ! parameters.
	   read(21,*) keyword                       ! This reads the filename with the data
       read(21,*) ThreshCurv                    ! This reads the filename with the data
       read(21,*) ThreshVel

       point = index(keyword,'.') - 1

       write(6,5)'I am going to look for data in the file labeled: ', keyword
       close(21)

       ! This part is to determines the total number of lines
       ! in the data file and assigns it to the variable, nnline
		nnline = 0 ! Initialize counter
		open(41, file=keyword, status='old') ! open the file
 60     continue
		read(41,*,end=61) ! read line, if end of file, goto 61
		nnline=nnline+1  ! Increment counter
		goto 60
 61     continue
        close(41)  ! we are finished, close the file
		write(6,15) 'There are  ',nnline,' lines in the data file.'
		
        ! Check each line for the string '#'. If found, we know this line
        ! is part of the header.  If not, we have reached the data section.
	    open(41, file=keyword, status='old') ! open the file
        header = 0 ! Initialize counter
        hash = 0   ! Initialize flag
	    do i=1,nnline  ! loop over each line in the file
	     read(41, "(a)") inline    ! reads line into a string
	     hash = index(inline, '#') ! if the character "#" in the string, hash>1.
	     if (hash.ne.0) then       ! check the flag
	      header=header+1          ! when "#" found, it is a header line
		  hash=0                   ! reset the flag
	     else
		  goto 80                  ! when hash is = 0, we have reached the end of the header
	     endif
	    enddo  ! closes i=1,nnline
 80    close(41)				   ! close the file
	   write(6,*)header,' lines in the header'

	   ! This opens the output file, where results are written

       open(31, file=keyword(1:point)//'_cnd.txt', status='unknown')

       ! Now we read the data
       open(41, file=keyword, status='old') ! Open the input file
       nline = 0 ! Before reading the data, we have to read the neader
       do i=1,header
        read(41, "(a)") inline ! read a line of the header
        write(30, "(a)")inline ! write that line into the output file
        write(31, 6)inline
       enddo! closes i=1,header
       write(31, 5)'# written by condition faces: ',version
       write(31, 5)'# initial file: ',keyword
       write(31, 22)'# eliminated lines with curvature greater than',ThreshCurv
       write(31, 22)'# eliminated lines with velocity greater than',ThreshVel

       blank = 0  ! Initialize counter for zero Euler angle lines

       ! Next is the start of the main loop, reading reading and
       ! analyzing one line of data at a time.
       do kk=header+1,nnline !start on the line after the header, continue to end.
        read(41,*) e1(1), e1(2), e1(3), e2(1), e2(2), e2(3),
     &  normal(1),normal(2),normal(3),curv,dummy,dummy,dummy,
     &  dummy,area,dummy,dummy,dummy,vel
         area=abs(area)
         curv=abs(curv)
         vel=abs(vel)

        ! Outputs from some programs produce zero Euler angles when the
        ! when one or both orientiations are not known.  These lines are
        ! ignored because they will cause problems later.
		if (e1(1).eq.0.00.and.e1(2).eq.0.00.and.e1(3).eq.0.00) then
          blank=blank+1 ! increment counter
		  goto 1000 ! Sends it to the next line
        else
          continue
		endif
        if (e2(1).eq.0.00.and.e2(2).eq.0.00.and.e2(3).eq.0.00) then
          blank=blank+1 ! increment counter
          goto 1000 ! Sends it to the next line
        else
          continue
        endif

        if (curv.gt.ThreshCurv) then
         high_val=high_val+1
         goto 1000
        else
         if (vel.gt.ThreshVel) then
          high_vel=high_vel+1
          goto 1000
         else
          write(31,24) e1(1), e1(2), e1(3), e2(1), e2(2), e2(3), normal(1),normal(2),normal(3), area, curv, vel
         endif
        endif

         ! when you reach this point, the line has been written or ignored
 1000    continue ! so we go to the next line of the data file and repeat
       enddo    ! This closes kk=header+1,nnline, the loop over each line of data.


 9000    continue
         write(6,*)'high_val=',high_val
         write(6,*)'high_vel=',high_vel
         write(6,*)'blank',blank
         write(6,*)'final number of lines =',nnline-header-blank-high_val-high_vel
         close(31)
       end






	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   
	   